package de.hdm_stuttgart.mi.sd1.task1;

/**
 * <p>ASCII art related method.</p>
 */
public class D_TextFrame {

    /**
     * <p>Arranging a list of strings line by line and surrounding it by a rectangular frame. The following
     * example transforms an array containing two strings into a corresponding framed output:</p>
     *
     * <table class="goikTableDefaults">
     *     <caption>ASCII art frame</caption>
     *     <tbody>
     *         <tr>
     *             <th>Code</th>
     *             <th>Result</th>
     *         </tr>
     *         <tr>
     *             <td>
     *                 <pre><code class="java"> final String[] words = {"This is a first", "sample"};
     * System.out.println(createTextFrame(words));</code></pre>
     *             </td>
     *             <td>
     *                 <pre><code class="nohighlight"> *******************
     * * This is a first *
     * * sample          *
     * *******************</code></pre>
     *             </td>
     *         </tr>
     *     </tbody>
     * </table>
     *
     * <p>Note the additional empty spaces »<span style="color:red;font-weight:bold;">_</span>« between each
     * starting * and before each ending *:</p>
     *
     * <pre><code class="nohighlight"> *******************
     * *<span style="color:red;font-weight:bold;">_</span>This is a first<span style="color:red;font-weight:bold;">_</span>*
     * *<span style="color:red;font-weight:bold;">_</span>sample         <span style="color:red;font-weight:bold;">_</span>*
     * *******************</code></pre>
     *
     * @param strings A non-empty array possibly containing both strings and <code>null</code> values.
     * @return An ASCII frame surrounding lines of text.
     *
     * <section class="implementationHints">
     *    <h4>Hints:</h4>
     *
     * <ul>
     *     <li>You may use {@link B_StringHelper#getMaxLength(String[])} to get the longest
     *     string length in the list for sizing your frame.</li>
     *
     *     <li>{@link String#repeat(int)} for repeating both <code>"*"</code> and empty spaces <code>" "</code>
     *     using e.g. <code>"*".repeat(10)</code>.</li>
     *
     *     <li>Watch out for spaces and invisible newlines at end of your returned string. These are difficult to spot
     *     and may cause tests to fail.</li>
     *
     * </ul>
     *
     * </section>
     */
    static public String createTextFrame(final String[] strings) {


        return "***"; // TODO: Implement me correctly
    }

    private D_TextFrame(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
