package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.B_StringHelper.getMaxLength;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class B_StringHelperTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 2)
    public void test_100_minimum() {
        Assert.assertEquals(0, getMaxLength(new String[]{null}));
        Assert.assertEquals(0, getMaxLength(new String[]{""}));
    }

    @Test
    @Marking(points = 6)
    public void test_200_single() {
        Assert.assertEquals(1, getMaxLength(new String[]{"a"}));
        Assert.assertEquals(11, getMaxLength(new String[]{"csd wde dwe"}));
    }

    @Test
    @Marking(points = 6)
    public void test_300_multi() {
        Assert.assertEquals(1, getMaxLength(new String[]{"a", "b", "c"}));
        Assert.assertEquals(5, getMaxLength(new String[]{"Eve", "Peter", "Jill", "Tom"}));
        Assert.assertEquals(12, getMaxLength(new String[]{"Looooooooong", "Loooooong", null, "Looong", null}));
        Assert.assertEquals(12, getMaxLength(new String[]{null, "Loooooong", "Looooooooong", "Looong", null}));
    }
}
