package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.C_ArrayHelper.getAboveAverage;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class C_ArrayHelperTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 2)
    public void test_100_minimum() {
        Assert.assertArrayEquals(new int[]{}, getAboveAverage(new int[]{1}));
    }

    @Test
    @Marking(points = 4)
    public void test_200_equal() {
        Assert.assertArrayEquals(new int[]{}, getAboveAverage(new int[]{20, 20}));
        Assert.assertArrayEquals(new int[]{}, getAboveAverage(new int[]{7, 7, 7, 7}));
    }

    @Test
    @Marking(points = 4)
    public void test_200_regular() {
        Assert.assertArrayEquals(new int[]{1}, getAboveAverage(new int[]{1, 0}));
        Assert.assertArrayEquals(new int[]{1}, getAboveAverage(new int[]{0, 1}));
        Assert.assertArrayEquals(new int[]{5, 4}, getAboveAverage(new int[]{1, 2, 3, 5, 4}));
        Assert.assertArrayEquals(new int[]{55, 100}, getAboveAverage(new int[]{-30, 2, 4, 55, 100, 9}));

        Assert.assertArrayEquals(new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0},
                getAboveAverage(new int[]{0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0,0, 0, 0}));

        Assert.assertArrayEquals(new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0},
                getAboveAverage(new int[]{-1, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0}));

        Assert.assertArrayEquals(new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0},
                getAboveAverage(new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, -1}));
    }

    @Test
    @Marking(points = 2)
    public void test_200_big() {
        Assert.assertArrayEquals(new int[]{Integer.MAX_VALUE, Integer.MAX_VALUE},
                getAboveAverage(new int[]{0, Integer.MAX_VALUE, Integer.MAX_VALUE}));

        Assert.assertArrayEquals(new int[]{Integer.MAX_VALUE, Integer.MAX_VALUE},
                getAboveAverage(new int[]{Integer.MAX_VALUE, 0, Integer.MAX_VALUE}));

        Assert.assertArrayEquals(new int[]{Integer.MAX_VALUE, Integer.MAX_VALUE},
                getAboveAverage(new int[]{Integer.MAX_VALUE, Integer.MAX_VALUE, 0}));
    }
}
