package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task1.D_TextFrame.createTextFrame;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class D_TextFrameTest extends ExaminationTestDefaults {

    @Test
    @Marking(points = 2)
    public void test_100_minimum() {

        final String expected = """
                ****
                *  *
                ****""";

        Assert.assertEquals(expected, createTextFrame(new String[]{null}));
        Assert.assertEquals(expected, createTextFrame(new String[]{""}));
    }

    @Test
    @Marking(points = 2)
    public void test_200_one() {

        {
            final String expected = """
                    *****
                    *   *
                    *****""";

            Assert.assertEquals(expected, createTextFrame(new String[]{" "}));
        }
        {
            final String expected = """
                    *****
                    * j *
                    *****""";

            Assert.assertEquals(expected, createTextFrame(new String[]{"j"}));
        }
    }

    @Test
    @Marking(points = 2)
    public void test_300_multi() {

        {
            final String expected = """
                    ******************
                    * This is a very *
                    * simple test.   *
                    ******************""";

            Assert.assertEquals(expected, createTextFrame(new String[]{"This is a very", "simple test."}));
        }
        {
            final String expected = """
                    *******************
                    * An example      *
                    * featuring three *
                    * lines           *
                    *******************""";

            Assert.assertEquals(expected, createTextFrame(new String[]{"An example", "featuring three", "lines"}));
        }
    }

    @Test
    @Marking(points = 2)
    public void test_400_null() {

        final String expected = """
                    **********************
                    * Sometimes there is *
                    *                    *
                    * a hole.            *
                    *                    *
                    **********************""";

        Assert.assertEquals(expected, createTextFrame(new String[]{"Sometimes there is", null, "a hole.", null}));
    }
}
